 Member
!_ABCDllMode_  EQUATE(0)
!_ABCLinkMode_ EQUATE(1)
 !note to users
 ! the long equate returned should be decoded with the equates in the inc file
 ! the value of the equates will change over time!
 ! for example, If I can figure out how I will identify WinNT less than ver4 as
 ! different than winNT
 ! for the paramters to getOS string(20) is a safe length for pVerStr
 ! dont count on the string return in pVerStr to stay stable over time
 ! use it blindly for display when a short os description is needed
 ! if the os is unknown, pverstr is blank. you may depend on that behavior
 Map
   !Local Procedures, if any, go here
   !API Prototypes
   Module('api')
      GetLastError(),ULONG,PASCAL
      GetVersionEx(*_OSVERSIONINFOEX lpOsVerInfo |
                       ),LONG,RAW,PASCAL,NAME('GetVersionExA')
      RegOpenKeyEx(UNSIGNED hKey,       |
                   *CSTRING lpSubKey,   |
                   LONG ulOptions=0,    | reserved (unused must be null)
                   LONG samDesired,     |
                   *LONG phkResult      |
                  ),LONG,RAW,PASCAL,PROC,NAME('RegOpenKeyExA')
      RegQueryValueEx(UNSIGNED hKey,           | handle to key
                      *CSTRING lpValueName,    | value name
                      LONG lpReserved=0,       | reserved (unused mustbe null)
                      <*? lpType>,             | type buffer
                      <*? lpData>,             | data buffer
                      <*? lpcbData>            | size of data buffer
                     ),LONG,RAW,PASCAL,PROC,NAME('RegQueryValueExA')
      RegCloseKey(LONG hKey),LONG,RAW,PASCAL,PROC
    END
 end

!Includes this class and others
 include('osvercl.inc')

!global data for this module
Return:Benign equate(0)
Return:Fatal  equate(3)
Return:Notify equate(5)
_OSVERSIONINFO     GROUP,TYPE
dwOSVersionInfoSize  ULONG
dwMajorVersion       ULONG
dwMinorVersion       ULONG
dwBuildNumber        ULONG
dwPlatformId         ULONG
szCSDVersion         CSTRING(128)
                   END

_OSVERSIONINFOEX   GROUP(_OSVERSIONINFO),TYPE
wServicePackMajor    USHORT
wServicePackMinor    USHORT
wSuiteMask           USHORT
wProductType         BYTE
wReserved            BYTE
                 END

! Registry key values
HKEY_LOCAL_MACHINE          EQUATE(80000002h)
KEY_QUERY_VALUE             EQUATE(00000001h)


VER_PLATFORM_WIN32s                 EQUATE(0)
VER_PLATFORM_WIN32_WINDOWS          EQUATE(1)
VER_PLATFORM_WIN32_NT               EQUATE(2)

! RtlVerifyVersionInfo() type mask bits
VER_MINORVERSION                    EQUATE(0000001h)
VER_MAJORVERSION                    EQUATE(0000002h)
VER_BUILDNUMBER                     EQUATE(0000004h)
VER_PLATFORMID                      EQUATE(0000008h)
VER_SERVICEPACKMINOR                EQUATE(0000010h)
VER_SERVICEPACKMAJOR                EQUATE(0000020h)
VER_SUITENAME                       EQUATE(0000040h)
VER_PRODUCT_TYPE                    EQUATE(0000080h)

! RtlVerifyVersionInfo() os product type values
VER_NT_WORKSTATION                  EQUATE(0000001h)
VER_NT_DOMAIN_CONTROLLER            EQUATE(0000002h)
VER_NT_SERVER                       EQUATE(0000003h)

VER_SUITE_SMALLBUSINESS             EQUATE(00000001h)
VER_SUITE_ENTERPRISE                EQUATE(00000002h)
VER_SUITE_BACKOFFICE                EQUATE(00000004h)
VER_SUITE_COMMUNICATIONS            EQUATE(00000008h)
VER_SUITE_TERMINAL                  EQUATE(00000010h)
VER_SUITE_SMALLBUSINESS_RESTRICTED  EQUATE(00000020h)
VER_SUITE_EMBEDDEDNT                EQUATE(00000040h)
VER_SUITE_DATACENTER                EQUATE(00000080h)
VER_SUITE_SINGLEUSERTS              EQUATE(00000100h)
VER_SUITE_PERSONAL                  EQUATE(00000200h)




!-------------------------------------------------------------
!---Start of osvercl
!-------------------------------------------------------------
osverclType.getos                  Procedure(*string pverstr, *long pvernum, *long pSP)
osvi                LIKE(_OSVERSIONINFOEX),AUTO
bOsVersionInfoEx    BOOL,AUTO
hRegKey             UNSIGNED,AUTO
szProductType       CSTRING(16),AUTO
szRegValueName      CSTRING(16),AUTO
szRegSubKey         CSTRING(64),AUTO
dwBufLen            LONG,AUTO
res                 byte(return:benign)
  Code
  !get the basic os info from getversionex
  !-----------------------------------------------
  ! First try to use the _ex structure
  !-----------------------------------------------
  osvi.dwOsVersionInfoSize = SIZE(_OSVERSIONINFOEX)
  bOsVersionInfoEx = GetVersionEx(osvi)

  !-----------------------------------------------
  ! The _ex structure didn't work, try the normal one
  !-----------------------------------------------
  IF NOT bOsVersionInfoEx
    CLEAR(osvi)
    osvi.dwOsVersionInfoSize = SIZE(_OSVERSIONINFO)
    IF NOT GetVersionEx(osvi)
      !-----------------------------------------
      ! Nothing worked, so ensure the parameters
      ! are cleared.
      !-----------------------------------------
      !clear the input
      clear(pverstr)
      clear(pvernum)
      clear(psp)
      RETURN return:fatal
    END
  END
  !Message(osvi.dwplatformID,'platformid')
  !message(osvi.dwMajorversion,'majver')
  !message(osvi.dwminorversion,'minorver')
  !we have the os info now try to make sense of it
  case osvi.dwPlatformID
  of 0 !Ver_Platform_Win32s
    pVerStr='Win32s'
    pVernum=osWin32s
    pSP=0
  of 1 !Ver_Platform_WIN32_Windows
    IF osvi.dwMajorVersion = 4 AND osvi.dwMinorVersion = 0
      IF osvi.szCSDVersion[2] = 'C'
        pVerStr='Win95b'
        pVernum=OsWin95b
        pSp=0
      else
        pverStr='Win95a'
        pvernum=osWin95a
        pSp=0
      END
    ELSIF osvi.dwMajorVersion = 4 AND osvi.dwMinorVersion = 10
      IF osvi.szCSDVersion[2] = 'A'
        pVerStr='Win98SE'
        pVernum=osWin98SE
        pSp=0
      else
        pVerStr='Win98'
        pVernum=osWin98
        pSp=0
      END
    ELSIF osvi.dwMajorVersion = 4 AND osvi.dwMinorVersion = 90
      pverstr='WinME'
      pVerNum=OSWinME
      psp=0
    ELSE
      res=return:fatal
      clear(pverstr)
      clear(pvernum)
      clear(psp)
    END
  of 2 !Ver_Platform_win32_NT
    IF osvi.dwMajorVersion > 0 AND osvi.dwMajorVersion <= 4
      pVerStr='WinNT'
      pVerNum=oswinNT
      pSp=osvi.wServicePackMajor
    ELSIF osvi.dwMajorVersion = 5 AND osvi.dwMinorVersion = 0
      pVerStr='Win2K'
      pVerNum=oswin2k
      pSp=osvi.wServicePackMajor
    ELSIF osvi.dwMajorVersion = 5 AND osvi.dwMinorVersion = 1
      pVerStr='WinXP'
      pVerNum=oswinXP
      pSp=osvi.wServicePackMajor
    ELSIF osvi.dwMajorVersion = 5 AND osvi.dwMinorVersion = 2
      pVerStr='Win2003'
      pVerNum=oswin2003
      pSp=osvi.wServicePackMajor
    ELSE
      res=return:fatal
      clear(pverstr)
      clear(pvernum)
      clear(psp)
    END
  else
    res=return:fatal
    clear(pverstr)
    clear(pvernum)
    clear(psp)
  end
  Return res


   omit('***')
    !-----------------------------------------------
    ! Now find the specific version of the major type.
    ! If _Ex structure is filled, then use it's info
    ! to determine the version.
    !-----------------------------------------------
    IF bOsVersionInfoEx AND osvi.dwMajorVersion > 4
      CASE osvi.wProductType
      OF VER_NT_WORKSTATION
        IF BAND(osvi.wSuiteMask, VER_SUITE_PERSONAL)
          pWinVerInfo.szPlatform = pWinVerInfo.szPlatform & ' Personal'
        ELSE
          pWinVerInfo.szPlatform = pWinVerInfo.szPlatform & '
Professional'
        END

      OF VER_NT_SERVER
         IF BAND(osvi.wSuiteMask, VER_SUITE_DATACENTER)
           pWinVerInfo.szPlatform = pWinVerInfo.szPlatform & '
DataCenter Server'
         ELSIF BAND(osvi.wSuiteMask, VER_SUITE_ENTERPRISE)
           pWinVerInfo.szPlatform = pWinVerInfo.szPlatform & ' Advanced
Server'
         ELSE
           pWinVerInfo.szPlatform = pWinVerInfo.szPlatform & ' Server'
         END

      END

    !-----------------------------------------------
    ! The _Ex structure wasn't filled, so use  the
    ! registry entries to determine the version
    !-----------------------------------------------
    ELSE
      szProductType = ''
      szRegSubKey = 'SYSTEM\CurrentControlSet\Control\ProductOptions'
      hRegKey = 0
      IF NOT RegOpenKeyEx( HKEY_LOCAL_MACHINE, szRegSubKey, ,
KEY_QUERY_VALUE, hRegKey )
        szRegValueName = 'ProductType'
        dwBufLen = SIZE(szRegValueName)-1
        RegQueryValueEx( hRegKey, szRegValueName, , , szProductType,
dwBufLen)
        RegCloseKey( hRegKey )
      END

      IF UPPER(szProductType) = 'WINNT'
         pWinVerInfo.szPlatform = pWinVerInfo.szPlatform & '
Workstation'
      ELSIF UPPER(szProductType) = 'SERVERNT'
         pWinVerInfo.szPlatform = pWinVerInfo.szPlatform & ' Server'
      END

    END
    pWinVerInfo.szServicePack = osvi.szCSDVersion
    ***